#!/usr/local/bin/perl
# 
# $Header: tfa/src/orachk/src/auto_upgrade.pl gadiga_orachk_0912/1 2014/09/17 11:26:11 gadiga Exp $
#
# auto_upgrade.pl
# 
# Copyright (c) 2014, Oracle and/or its affiliates. All rights reserved.
#
#    NAME
#      auto_upgrade.pl - <one-line expansion of the name>
#
#    DESCRIPTION
#      <short description of component this file declares/defines>
#
#    NOTES
#      <other useful comments, qualifications, etc.>
#
#    MODIFIED   (MM/DD/YY)
#    apriyada    09/12/14 - Print Version
#    apriyada    05/07/14 - Auto upgrade orachk
#    apriyada    05/07/14 - Creation
#

use warnings;
#use Switch;

my ($program_name) = $ARGV[0];
my ($mypref) = $ARGV[1];
my($ORACHK_LOC) = $ARGV[2];
my($workdir) = $ARGV[3];
my($selectedpath) = $ARGV[4];

my($ZIP) = `which unzip`;
$zipstat = `echo $?`;
chomp($ZIP);
$usrname = `id -u -n`;chomp($usrname);

if($zipstat == 1)
{
	$platform = `/bin/uname`;

	if($platform eq "Linux" || $platform eq "HP-UX" || $platform eq "AIX")
	{
		$ORATAB="/etc/oratab";
	}
	elsif($platform eq "SunOS")
	{
		$ORATAB="/var/opt/oracle/oratab";
	}
	else
	{
		print "\nERROR: Unknown Operating System\n";
	}
	if ( -e "$ORATAB" )
 	{
        	foreach $var (`grep ":/" $ORATAB |grep -v "+"|grep -v "^#"|cut -d: -f2`)
		{
			if(-e "$var/bin/unzip")
			{
				$ZIP="$var/bin/unzip";
				$zipstat = 0;
			}
		}

	}

}

my ($pdir) = `pwd`;
$pdir =~ s/\s//g;

sub show_version 
{
  $collfile = $_[0];
  if ( -e "$workdir/cgrep" ) {
    $dataFilesDateval=`$workdir/cgrep FILE_DATE $collfile`;
  } else {
    $dataFilesDateval=`/bin/grep FILE_DATE $collfile`;
  }
  @tmpvals = split(/ /,$dataFilesDateval);
  $dataFilesDate = $tmpvals[2];
  $dataFIleMonth=`echo $dataFilesDate|cut -d- -f2|tr "[a-z]" "[A-Z]"`;
  $dataFIleMonth =~ s/\s//g;
   
  if($dataFIleMonth eq "JAN")
  {
	$dataFIleMonthNo = "01";
  } 
  elsif($dataFIleMonth eq "FEB")
  {
        $dataFIleMonthNo = "02";
  }
  elsif($dataFIleMonth eq "MAR")
  {
        $dataFIleMonthNo = "03";
  }
  elsif($dataFIleMonth eq "APR")
  {
        $dataFIleMonthNo = "04";
  }
  elsif($dataFIleMonth eq "MAY")
  {
        $dataFIleMonthNo = "05";
  }
  elsif($dataFIleMonth eq "JUN")
  {
        $dataFIleMonthNo = "06";
  }
  elsif($dataFIleMonth eq "JUL")
  {
        $dataFIleMonthNo = "07";
  }
  elsif($dataFIleMonth eq "AUG")
  {
        $dataFIleMonthNo = "08";
  }
  elsif($dataFIleMonth eq "SEP")
  {
        $dataFIleMonthNo = "09";
  }
  elsif($dataFIleMonth eq "OCT")
  {
        $dataFIleMonthNo = "10";
  }
  elsif($dataFIleMonth eq "NOV")
  {
        $dataFIleMonthNo = "11";
  }
  else
  {
        $dataFIleMonthNo = "12";
  }

  $dataFIleDay=`echo $dataFilesDate|cut -d- -f1|tr "[a-z]" "[A-Z]"`;
  $dataFIleYear=`echo $dataFilesDate|cut -d- -f3|tr "[a-z]" "[A-Z]"`;  
  $dataFIleYear =~ s/\s//g;
  $dateval = "$dataFIleYear$dataFIleMonthNo$dataFIleDay";
  return $dateval; 
}


if($mypref eq "-check")
{
	$ORACHK_LOC =~ s/RAT_UPGRADE_LOC=//g;
	my ($pdir) = `pwd`;
	$pdir =~ s/\s//g;
#	$cur_ver = `bash $pdir/$program_name -v`;
#	$cur_ver =~ s/\s//g;
        $cur_ver_no = show_version("collections.dat");
#	my($cur_ver_no) = (split /_/, $cur_ver)[-1];

	my($selectedpath)=".";

	my (@loc)= split(/,/,$ORACHK_LOC);
	foreach $locval (@loc)
	{
		chomp($locval);

		if (-f "$locval/$program_name.zip")
		{
			chdir "$locval/";
			if ( -e "$locval/extract_files/collections.dat" )
			{
				$loccoltimestamp = `ls -l $locval/extract_files/collections.dat`;
				if($zipstat == 0)
				{
                        		$coltimestamp = `$ZIP -l $locval/$program_name.zip |grep collections.dat`;
				}
				else
				{
					$selectedpath = "-1";
					last;
				}		
                         
				@tmp = split(/ /,$loccoltimestamp);$sizelocal = $tmp[4];
				@tmp1 = split(/ /,$coltimestamp); $sizezip = $tmp1[1];
				if($sizelocal ne "$usrname" && $sizezip ne "$usrname")
				{
					if($sizelocal != $sizezip)
					{
						chdir "extract_files";
						`$ZIP -o "../$program_name.zip"`;
					}
				}
			}
			unless(-e "$locval/extract_files/collections.dat")
			{
				 `mkdir extract_files`;
				 chdir "extract_files";
				if($zipstat == 0)
                                {
					`$ZIP -o "../$program_name.zip"`;
				}
				else
				{
					$selectedpath = "-1";
					last;
				}
			}
		}

        	if ( -e "$locval/extract_files/collections.dat" )
	       	{
                	#$ver_at_loc=`bash $locval/$program_name -v`;
			#$ver_at_loc =~ s/\s//g;
	                #$veratloc_no=(split /_/, $ver_at_loc)[-1];
			$veratloc_no=show_version("$locval/extract_files/collections.dat");
                	if ( $veratloc_no > $cur_ver_no )
        	        {
				`touch $workdir/versionfil.dat`;
				`echo "$veratloc_no" > $workdir/versionfil.dat`;
	                        $selectedpath="$locval/extract_files";
                        	$cur_ver_no=$veratloc_no;
                	}      
        	}          
	}

	chdir "$pdir/"; 

	if($selectedpath eq ".")
	{
		$ret_val="0";
	} 
	else
	{
		$ret_val="$selectedpath";
	}
	print $ret_val;
}
else
{
	@pathval = split(/,/,$selectedpath);
	my ($timestamp) = `date '+%m%d%y_%H%M%S'`;
	my (@backup_files) = ($program_name, '.cgrep', 'readme.txt', 'UserGuide.txt', 'rules.dat', 'collections.dat' );
	`mkdir back_up_${program_name}_$timestamp`;
	foreach $val (@backup_files)
	{
        	`cp -R -f $val back_up_${program_name}_$timestamp`;
	        `cp -R -f $pathval[0]/$val .`;
	}
	$upgraded_ver = `bash ./$program_name -v`;
	$upgraded_ver =~ s/\s//g;$upgraded_ver =~ s/RACCHECKVERSION://g;
	print "\n\n$program_name has been upgraded to $upgraded_ver\n\n";

}
